#include <QApplication>
#include <QIcon>
#include <QPainter>
#include <QImage>
#include <QLabel>

int main(int argc, char** argv)
{
    QApplication app(argc, argv);

    QIcon icon;
    icon.addFile(QStringLiteral(":/off.svg"), QSize(), QIcon::Normal, QIcon::Off);
    icon.addFile(QStringLiteral(":/on.svg"), QSize(), QIcon::Normal, QIcon::On);

    QImage img(64, 192, QImage::Format_ARGB32);
    img.fill(Qt::white);
    QPainter p(&img);
    icon.paint(&p, 0, 0, 32, 32, Qt::AlignCenter, QIcon::Normal, QIcon::Off);
    icon.paint(&p, 0, 32, 32, 32, Qt::AlignCenter, QIcon::Normal, QIcon::On);
    icon.paint(&p, 0, 64, 32, 32, Qt::AlignCenter, QIcon::Disabled, QIcon::Off);
    icon.paint(&p, 0, 96, 32, 32, Qt::AlignCenter, QIcon::Disabled, QIcon::On);
    icon.paint(&p, 0, 128, 32, 32, Qt::AlignCenter, QIcon::Active, QIcon::Off);
    icon.paint(&p, 0, 160, 32, 32, Qt::AlignCenter, QIcon::Active, QIcon::On);
    icon.paint(&p, 0, 128, 32, 32, Qt::AlignCenter, QIcon::Selected, QIcon::Off);
    icon.paint(&p, 0, 160, 32, 32, Qt::AlignCenter, QIcon::Selected, QIcon::On);

    QIcon pngicon;
    pngicon.addFile(QStringLiteral(":/off.png"), QSize(), QIcon::Normal, QIcon::Off);
    pngicon.addFile(QStringLiteral(":/on.png"), QSize(), QIcon::Normal, QIcon::On);

    pngicon.paint(&p, 32, 0, 32, 32, Qt::AlignCenter, QIcon::Normal, QIcon::Off);
    pngicon.paint(&p, 32, 32, 32, 32, Qt::AlignCenter, QIcon::Normal, QIcon::On);
    pngicon.paint(&p, 32, 64, 32, 32, Qt::AlignCenter, QIcon::Disabled, QIcon::Off);
    pngicon.paint(&p, 32, 96, 32, 32, Qt::AlignCenter, QIcon::Disabled, QIcon::On);
    pngicon.paint(&p, 32, 128, 32, 32, Qt::AlignCenter, QIcon::Active, QIcon::Off);
    pngicon.paint(&p, 32, 160, 32, 32, Qt::AlignCenter, QIcon::Active, QIcon::On);
    pngicon.paint(&p, 32, 128, 32, 32, Qt::AlignCenter, QIcon::Selected, QIcon::Off);
    pngicon.paint(&p, 32, 160, 32, 32, Qt::AlignCenter, QIcon::Selected, QIcon::On);

    QLabel l;
    l.setPixmap(QPixmap::fromImage(img));
    l.show();
	return app.exec();
}
